using System;
using System.Collections;
using System.Text;
using System.Drawing;
using Syncfusion.Windows.Forms.Tools;
using System.Windows.Forms;
namespace CustomDraw
{
    public class CustomCaptionPainter:CaptionPainter 
    {
        public CustomCaptionPainter(DockHostController dcb)
            : base(dcb)
        {

        }

        #region CUSTOM_PAINTING_OVERRIDES
        public Rectangle CustomCaptionButtonRectangle
        {
            get{
                //if (this.dhcOwner.MaximizeButtonVisibility)
                
                    //return new Rectangle(this.MenuButtonRect.X - 32, MenuButtonRect.Y, AutoHideButtonRect.Width, AutoHideButtonRect.Height);
                //else
                    return new Rectangle(this.MenuButtonRect.X - 17, MenuButtonRect.Y, AutoHideButtonRect.Width, AutoHideButtonRect.Height);
            }
        }

        public override void PaintCaption(Graphics gph, Pen pen)
        {
            base.PaintCaption(gph, pen);
            PaintEventArgs pea = new PaintEventArgs(gph, Rectangle.Empty);
            CustomDockingManager cdm = (CustomDockingManager)this.dhcOwner.DockingManager;
            cdm.OnCaptionPaint(pea);
            PaintCustomButton(gph,pen );
            //gph.DrawString("HI", new Font("Times new roman", 10), Brushes.Red, 10, 10);
        }
        public virtual void PaintCustomButton(Graphics gph,Pen p)
        {           
            if(bLBtnDown && CustomCaptionButtonRectangle.Contains(this.dhcOwner.HostControl.PointToClient( Control.MousePosition)))
                ControlPaint.DrawButton(gph,CustomCaptionButtonRectangle ,ButtonState.Pushed );
            else 
                ControlPaint.DrawButton(gph, CustomCaptionButtonRectangle, ButtonState.Normal);
            if (CustomCaptionButtonRectangle.Contains(this.dhcOwner.HostControl.PointToClient(Control.MousePosition)) && Control.MouseButtons == MouseButtons.Left)
            {
                CustomDraw.CustomDockingManager cDockMgr = this.dhcOwner.DockingManager as CustomDraw.CustomDockingManager;
                cDockMgr.OnCustomButtonClicked();
            }
        }
        bool bLBtnDown=false;
        public override CaptionPainter.CaptionHitTest HitTest(MouseAction action, Point pt)
        {
            if (action==MouseAction.LBtnDown) bLBtnDown = true;
             if(action==MouseAction.LBtnUp) bLBtnDown = false;
            return base.HitTest(action, pt);
        }
        #endregion CUSTOM_PAINTING_OVERRIDES
    }
}
